set_time = 0
alt_set_time = 0
fuel_setting = ""
fuel_amount = 0
fuels = {}


function on_load_fuels()
	fuels = {}
	for j, item in pairs (game.item_prototypes) do
		if item.fuel_category == "chemical" then
			table.insert(fuels, item)
			game.print("fuel array")
		end
	end
end	



function on_selected_area(event)
	if event.item ~= "easy-copy-tool" then
		return 
	end
	if #fuels == 0 then
		on_load_fuels()
	end
	set_time = 	game.players[event.player_index].mod_settings["set_time"].value
	glob_set_time = set_time
	fuel_setting = game.players[event.player_index].mod_settings["fuel_setting"].value
	fuel_amount = game.players[event.player_index].mod_settings["fuel_amount"].value
	on_selected_area_pr(event)
end

function on_alt_selected_area(event)
	if event.item ~= "easy-copy-tool" then
		return 
	end
	if #fuels == 0 then
		on_load_fuels()
	end
	set_time = 	game.players[event.player_index].mod_settings["alt_set_time"].value
	glob_set_time = set_time * 2
	fuel_setting = game.players[event.player_index].mod_settings["fuel_setting"].value
	fuel_amount = game.players[event.player_index].mod_settings["fuel_amount"].value	
	on_selected_area_pr(event)
end

function on_selected_area_pr(event)
	local beacons = {}
	local inserter = {}
	for i, building in pairs (event.entities) do
		if building.type == "beacon" then
			table.insert(beacons, building)
		end
		if building.type == "inserter" then
			if building.drop_target ~= nil and building.pickup_target ~= nil then
				if building.drop_target.type == "assembling-machine" then
					if building.drop_target.get_recipe() ~= nil then
						if building.pickup_target.type == "logistic-container" then
							if building.pickup_target.prototype.logistic_mode == "requester" then
								table.insert(inserter, building)
								for j=1, building.pickup_target.request_slot_count do
									building.pickup_target.clear_request_slot(j) 
								end
							end
						end
					end
				end
			end
		end
	end
	for p, building in pairs (inserter) do
		local control = 0
		if building.drop_target.type == "assembling-machine" then
			if building.drop_target.get_recipe() ~= nil then
				if building.pickup_target.type == "logistic-container" then
					if building.pickup_target.prototype.logistic_mode == "requester" then
						local assembly_entity = building.drop_target
						local requester_entity = building.pickup_target
						local tot_ins = 1
						for k, partner in pairs (inserter) do
							if k ~= p and partner.drop_target == assembly_entity then
								tot_ins = tot_ins + 1
							end
						end						
						local assembly_speed = assembly_entity.prototype.crafting_speed
						local assembly_recipe = assembly_entity.get_recipe()
						local assembly_module_effect = calculate_module_speed(assembly_entity)
						local beaconed_effect = check_beacon_range(assembly_entity, beacons)
						local recipe_ips = calculate_usage (assembly_recipe, assembly_speed, assembly_module_effect, beaconed_effect, tot_ins)
						
						control = control + #recipe_ips
						for i=1, #recipe_ips do
							for j=1, requester_entity.request_slot_count do
								if requester_entity.get_request_slot(j) == nil then
									requester_entity.set_request_slot(recipe_ips[i], j)		
									break
								else
									if requester_entity.get_request_slot(j).name == recipe_ips[i].name then
										recipe_ips[i].count = recipe_ips[i].count + requester_entity.get_request_slot(j).count
										requester_entity.set_request_slot(recipe_ips[i], j)											
										break
									end
								end
							end
						end
						if assembly_entity.prototype.burner_prototype.fuel_categories["chemical"] == true then
							local need_fuel = true
							--game.print("chemical tested")
							for i=1, requester_entity.request_slot_count do
								if need_fuel == false or requester_entity.get_request_slot(i) == nil  then
									break
								else
									for j, fuel in pairs (fuels) do
										if requester_entity.get_request_slot(i).name == fuel.name then
											need_fuel = false
											--game.print("fuel false")
											break
										end
									end	
								end
							end
							if need_fuel == true then
								--game.print("fuel true")
								for i=1, requester_entity.request_slot_count do
									if requester_entity.get_request_slot(i) == nil then
										local set_fuel = {}
										set_fuel[1] = {name = fuel_setting, count = fuel_amount}
										requester_entity.set_request_slot(set_fuel[1],i)
										--game.print("set fuel")
										break
									end
								end
							end
						end
						
					end
				end
			end
		end
	end
	game.players[event.player_index].print("[EasyCopy] [Hint] Calculation has been successful")
end

function calculate_usage (recipe, ass_speed, modules, beacon, partners)
	local recipe_ips = {}
	local r_time = recipe.energy
	local ingredients = recipe.ingredients
	local ips = ass_speed * (1 + modules + beacon)
	for i, k in pairs (ingredients) do
		local check = 0
		if k.type == "item" then
			check = check + k.amount * ips / (r_time * partners)
			r_count = k.amount * ips * set_time / (r_time * partners)
			r_count = r_count + upround(r_count)	
			recipe_ips[i] = {name = k.name, count = r_count}
		end
	end
	return recipe_ips
end

function calculate_module_speed(entity)
	local moduleinventory = entity.get_module_inventory()
	local modules = moduleinventory.get_contents()
	local total_speed = 0
	if moduleinventory == nil or moduleinventory.is_empty() then
		return 0
	end
	for name, modquant in pairs (modules) do 
		i_module = game.item_prototypes[name]
		effects = i_module.module_effects
		for eff, val in pairs (effects) do
			if eff == "speed" then
				total_speed = total_speed + val.bonus * modquant
			end

		end
	end
	if entity.type == "beacon" then
		local eff = entity.prototype.distribution_effectivity
		total_speed = total_speed * eff
	end
	if total_speed ~= 0 then
		return total_speed
	else
		return 0
	end
end

function check_beacon_range (assembly, beacons)
	local a_x = assembly.position.x
	local a_y = assembly.position.y
	local beacon_speed = 0
	for i, beacon in pairs (beacons) do
		local b_x = beacon.position.x
		local b_y = beacon.position.y
		local beacon_actual_range = beacon.prototype.supply_area_distance + 1
		local x_difference = 0
		local y_difference = 0
		if b_x > a_x then
			x_difference = b_x - a_x
		else
			x_difference = a_x - b_x
		end
		if b_y > a_y then
			y_difference = b_y - a_y
		else
			y_difference = a_y - b_y
		end
		if x_difference <= beacon_actual_range then
			if y_difference <= beacon_actual_range then
				beacon_speed = calculate_module_speed(beacon) + beacon_speed
			end			
		end
	end
	if beacon_speed ~= 0 then
		return beacon_speed
	else
		return 0
	end
end

function diff_val(num1, num2)
	num1 = num1/0.5 + (0.5-num1%0.5)
	num2 = num2/0.5 + (0.5-num2%0.5)	
	num1 = num1 - num1%1
	num2 = num2 - num2%1
	if num1 > num2 then
		return num1-num2
	else
		return num2-num1
	end
end

function upround(number)
	local x = number % 10
	local y = 10 - x
	if y == 10 then
		return 0
	else
		return y
	end
end

script.on_event(defines.events.on_player_selected_area, function(event)
on_selected_area(event)
end)

script.on_event(defines.events.on_player_alt_selected_area, function(event)
on_alt_selected_area(event)
end)

script.on_load(function()
fuels = {}
end)







