
script.on_event(defines.events.on_tick, function(event)
	local modTick = game.tick % 600

	if modTick == 0 then
		local providers = {}
		--debugPrint("Ticking")
		for i, force in pairs(game.forces) do 
			for ii, surface in pairs(force.logistic_networks) do 
				for ii, network in pairs(surface) do  
					for iii, provider in pairs(network.providers) do
						if provider.name == "logistic-chest-botUpgrader" then
							local inventory = provider.get_inventory(defines.inventory.chest)
							if inventory.is_empty() == false then
								--debugPrint("Found Provider")
								table.insert(providers, provider)
							end
						end
					end

					doUpgrade(network, providers)
					
					providers = {}
				end
			end
		end
	end
	
end
)


function doUpgrade(network, providers)
	local roboportWithInventory = {}
	for i, cell in pairs(network.cells) do 
		local owner = cell.owner
		local inventory = owner.get_inventory(defines.inventory.roboport_robot)
		if owner.type == "roboport" and inventory.is_empty() == false then
			table.insert(roboportWithInventory, owner)
		end
	end
	
	for i, provider in pairs (providers) do
		local source = provider.get_inventory(defines.inventory.chest)
		for itemSource, sizeSource in pairs(source.get_contents()) do
			for ii, roboport in pairs (roboportWithInventory) do
				local destination = roboport.get_inventory(defines.inventory.roboport_robot)
				for itemDestination, sizeDestination in pairs(destination.get_contents()) do
					if matchType(itemSource, itemDestination) then
						local count = 0
						local min = math.min(sizeSource, sizeDestination)
						if min > 0 then
							count = network.insert({name=itemDestination, count=min})
							if count > 0 then
								destination.remove({name=itemDestination, count=count})
								source.remove({name=itemSource, count=count})
								sizeSource = sizeSource - count
							end
							
							for index=1,count do 
								provider.surface.create_entity{name = game.item_prototypes[itemSource].place_result.name, position = provider.position, force=provider.force}
							end 
						end
					end
				end
			end
		end
	end
	
end

function matchType (source, destination)
	if source ~= destination and game.item_prototypes[source].place_result ~= nil and game.item_prototypes[source].place_result.type == game.item_prototypes[destination].place_result.type then
		return true
	end
end

function debugPrint(thing)
	for _, player in pairs(game.players) do
		player.print(serpent.block(thing))
	end
end